org.apache.hc.core5.http.message

## Class BasicHeaderValueParser

- java.lang.Object
- - org.apache.hc.core5.http.message.BasicHeaderValueParser

- All Implemented Interfaces:
    HeaderValueParser

      @Contract(threading=IMMUTABLE)
      public class BasicHeaderValueParser
      extends Object
      implements HeaderValueParser

  Default `HeaderValueParser` implementation.
  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BasicHeaderValueParser` | `INSTANCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicHeaderValueParser()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `HeaderElement[]` | `parseElements(CharSequence buffer, ParserCursor cursor)` Parses a header value into elements.
    `HeaderElement` | `parseHeaderElement(CharSequence buffer, ParserCursor cursor)` Parses a single header element.
    `NameValuePair` | `parseNameValuePair(CharSequence buffer, ParserCursor cursor)` Parses a name=value specification, where the = and value are optional.
    `NameValuePair[]` | `parseParameters(CharSequence buffer, ParserCursor cursor)` Parses a list of name-value pairs.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final BasicHeaderValueParser INSTANCE

  - ### Constructor Detail

    - #### BasicHeaderValueParser

          public BasicHeaderValueParser()

  - ### Method Detail

    - #### parseElements

          public HeaderElement[] parseElements(CharSequence buffer,
                                      ParserCursor cursor)

      Description copied from interface: `HeaderValueParser`
      Parses a header value into elements. Parse errors are indicated as `RuntimeException`.
      Specified by:
        `parseElements` in interface `HeaderValueParser`
      Parameters:
        `buffer` - buffer holding the header value to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        an array holding all elements of the header value

    - #### parseHeaderElement

          public HeaderElement parseHeaderElement(CharSequence buffer,
                                         ParserCursor cursor)

      Description copied from interface: `HeaderValueParser`
      Parses a single header element. A header element consist of a semicolon-separate list of name=value definitions.
      Specified by:
        `parseHeaderElement` in interface `HeaderValueParser`
      Parameters:
        `buffer` - buffer holding the element to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        the parsed element

    - #### parseParameters

          public NameValuePair[] parseParameters(CharSequence buffer,
                                        ParserCursor cursor)

      Description copied from interface: `HeaderValueParser`
      Parses a list of name-value pairs. These lists are used to specify parameters to a header element. Parse errors are indicated as `ParseException`.
      Specified by:
        `parseParameters` in interface `HeaderValueParser`
      Parameters:
        `buffer` - buffer holding the name-value list to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        an array holding all items of the name-value list

    - #### parseNameValuePair

          public NameValuePair parseNameValuePair(CharSequence buffer,
                                         ParserCursor cursor)

      Description copied from interface: `HeaderValueParser`
      Parses a name=value specification, where the = and value are optional.
      Specified by:
        `parseNameValuePair` in interface `HeaderValueParser`
      Parameters:
        `buffer` - the buffer holding the name-value pair to parse
        `cursor` - the parser cursor containing the current position and the bounds within the buffer for the parsing operation
      Returns:
        the name-value pair, where the value is `null` if no value is specified

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.